gstreamermm: Gst::RingBufferSpec Class Reference

Public Member Functions

# Gst::RingBufferSpec Class Reference

A class containing the format specification of a Gst::RingBuffer. More...

List of all members.

## Public Member Functions
| RingBufferSpec ()
| Default constructor.
| RingBufferSpec (const Glib::RefPtr< Gst::Caps >& caps, Gst::BufferFormatType type=Gst::BUFTYPE_LINEAR, Gst::BufferFormat format=Gst::UNKNOWN, bool sign=false, bool bigend=false, int width=0, int depth=0, int rate=0, int channels=0, guint64 latency_time=0, guint64 buffer_time=0, int segsize=0, int segtotal=0, int seglatency=0)
| Fully construct a Gst::RingBufferSpec.
| RingBufferSpec (GstRingBufferSpec& castitem, bool take_ownership=false)
| Construct a Gst::RingBufferSpec from a GstRingBufferSpec.
| RingBufferSpec (const RingBufferSpec& other)
| Copy constructor.
RingBufferSpec& | operator= (const RingBufferSpec& other)
| Assignment operator.
virtual | ~RingBufferSpec ()
| Destructor.
void | swap (RingBufferSpec& other)
GstRingBufferSpec* | gobj ()
| Gets the underlying gobject.
const GstRingBufferSpec* | gobj () const
| Gets the underlying gobject.
Glib::RefPtr< Gst::Caps > | get_caps ()
| Get the caps of the buffer (in).
Glib::RefPtr< const Gst::Caps > | get_caps () const
void | set_caps (const Glib::RefPtr< Gst::Caps >&value)
| Set the caps of the buffer (in).
Gst::BufferFormatType | get_type () const
| Get the sample type (in/out).
void | set_type (const Gst::BufferFormatType&value)
| Set the sample type (in/out).
Gst::BufferFormat | get_format () const
| Get the sample format (in/out).
void | set_format (const Gst::BufferFormat&value)
| Set the sample format (in/out).
bool | get_sign () const
| Get the sample sign (in/out).
void | set_sign (const bool&value)
| Set the sample sign (in/out).
bool | get_bigend () const
| Get the endianness of the samples (in/out).
void | set_bigend (const bool&value)
| Set the endianness of the samples (in/out).
int | get_width () const
| Get the width of the samples (in/out).
void | set_width (const int&value)
| Set the width of the samples (in/out).
int | get_depth () const
| Get the depth of the samples (in/out).
void | set_depth (const int&value)
| Set the depth of the samples (in/out).
int | get_rate () const
| Get the samplerate (in/out).
void | set_rate (const int&value)
| Set the samplerate (in/out).
int | get_channels () const
| Get the number of channels (in/out).
void | set_channels (const int&value)
| Set the number of channels (in/out).
guint64 | get_latency_time () const
| Get the latency in microseconds (in/out).
void | set_latency_time (const guint64&value)
| Set the latency in microseconds (in/out).
guint64 | get_buffer_time () const
| Get the total buffer size in microseconds (in/out).
void | set_buffer_time (const guint64&value)
| Set the total buffer size in microseconds (in/out).
int | get_segsize () const
| Get the size of one segment in bytes (in/out).
void | set_segsize (const int&value)
| Set the size of one segment in bytes (in/out).
int | get_segtotal () const
| Get the total number of segments (in/out).
void | set_segtotal (const int&value)
| Set the total number of segments (in/out).
int | get_seglatency () const
| Get the number of segments queued in the lower level device, defaults to segtotal (in/out).
void | set_seglatency (const int&value)
| Set the number of segments queued in the lower level device, defaults to segtotal (in/out).
int | get_bytes_per_sample () const
| Get the number of bytes of one sample (out).
void | set_bytes_per_sample (const int&value)
| Set the number of bytes of one sample (out).
Glib::ArrayHandle< guint8 > | get_silence_sample () const
| Get the bytes representing one sample of silence (out).
void | set_silence_sample (const Glib::ArrayHandle< guint8 >& silence_sample)
| Sets the bytes representing one sample of silence (out).

## Detailed Description

A class containing the format specification of a Gst::RingBuffer.

Gst::RingBufferSpec contains the format specification of a Gst::RingBuffer. The "in" members should be specified by the caller of the Gst::RingBuffer::acquire() method while the "in/out" members may be set by the caller but are also modifiable by Gst::RingBuffer::acquire(). The "out" members are generated as a result of the call to Gst::RingBuffer::acquire().

See also:
  Gst::RingBuffer::acquire().

## Constructor & Destructor Documentation

Gst::RingBufferSpec::RingBufferSpec | ( |  | ) |

Default constructor.

Exceptions:

  | std::runtime_error | if memory is unavailable for the new Gst::RingBufferSpec.

Gst::RingBufferSpec::RingBufferSpec | ( | const Glib::RefPtr< Gst::Caps >& | caps,
|  | Gst::BufferFormatType | type = `Gst::BUFTYPE_LINEAR`,
|  | Gst::BufferFormat | format = `Gst::UNKNOWN`,
|  | bool | sign = `false`,
|  | bool | bigend = `false`,
|  | int | width = `0`,
|  | int | depth = `0`,
|  | int | rate = `0`,
|  | int | channels = `0`,
|  | guint64 | latency_time = `0`,
|  | guint64 | buffer_time = `0`,
|  | int | segsize = `0`,
|  | int | segtotal = `0`,
|  | int | seglatency = `0` |
| ) |  |  |

Fully construct a Gst::RingBufferSpec.

Only the "(in)" parameters are required. The "(in/out)" parameters are optional and may be modified by the call to the Gst::RingBuffer::acquire() method.

Parameters:

  | caps | The caps of the buffer (in).
  | type | The sample type (in/out).
  | format | The sample format (in/out).
  | sign | The sample sign (in/out).
  | bigend | The endianness of the samples (in/out).
  | width | The width of the samples (in/out).
  | depth | The depth of the samples (in/out).
  | rate | The sample rate (in/out).
  | channels | The number of channels (in/out).
  | latency_time | The latency in microseconds (in/out).
  | buffer_time | The total buffer size in microseconds (in/out).
  | segsize | The size of one segment in bytes (in/out).
  | segtotal | The total number of segments (in/out).
  | seglatency | Number of segments queued in the lower level device, defaults to segtotal in the C API (in/out).

Exceptions:

  | std::runtime_error | if memory is unavailable for the new Gst::RingBufferSpec.

Gst::RingBufferSpec::RingBufferSpec | ( | GstRingBufferSpec & | castitem,
|  | bool | take_ownership = `false` |
| ) |  |  | `[explicit]`

Construct a Gst::RingBufferSpec from a GstRingBufferSpec.

Gst::RingBufferSpec::RingBufferSpec | ( | const RingBufferSpec& | other | ) |

Copy constructor.

Exceptions:

  | std::runtime_error | if memory is unavailable for the new Gst::RingBufferSpec.

virtual Gst::RingBufferSpec::~RingBufferSpec | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

bool Gst::RingBufferSpec::get_bigend | ( |  | ) | const

Get the endianness of the samples (in/out).

guint64 Gst::RingBufferSpec::get_buffer_time | ( |  | ) | const

Get the total buffer size in microseconds (in/out).

int Gst::RingBufferSpec::get_bytes_per_sample | ( |  | ) | const

Get the number of bytes of one sample (out).

This is set by the call to Gst::RingBuffer::acquire().

Glib::RefPtr<Gst::Caps> Gst::RingBufferSpec::get_caps | ( |  | ) |

Get the caps of the buffer (in).

Glib::RefPtr<const Gst::Caps> Gst::RingBufferSpec::get_caps | ( |  | ) | const

int Gst::RingBufferSpec::get_channels | ( |  | ) | const

Get the number of channels (in/out).

int Gst::RingBufferSpec::get_depth | ( |  | ) | const

Get the depth of the samples (in/out).

Gst::BufferFormat Gst::RingBufferSpec::get_format | ( |  | ) | const

Get the sample format (in/out).

guint64 Gst::RingBufferSpec::get_latency_time | ( |  | ) | const

Get the latency in microseconds (in/out).

int Gst::RingBufferSpec::get_rate | ( |  | ) | const

Get the samplerate (in/out).

int Gst::RingBufferSpec::get_seglatency | ( |  | ) | const

Get the number of segments queued in the lower level device, defaults to segtotal (in/out).

int Gst::RingBufferSpec::get_segsize | ( |  | ) | const

Get the size of one segment in bytes (in/out).

int Gst::RingBufferSpec::get_segtotal | ( |  | ) | const

Get the total number of segments (in/out).

bool Gst::RingBufferSpec::get_sign | ( |  | ) | const

Get the sample sign (in/out).

Glib::ArrayHandle<guint8> Gst::RingBufferSpec::get_silence_sample | ( |  | ) | const

Get the bytes representing one sample of silence (out).

This is set by the call to Gst::RingBuffer::acquire().

Gst::BufferFormatType Gst::RingBufferSpec::get_type | ( |  | ) | const

Get the sample type (in/out).

int Gst::RingBufferSpec::get_width | ( |  | ) | const

Get the width of the samples (in/out).

GstRingBufferSpec* Gst::RingBufferSpec::gobj | ( |  | ) | `[inline]`

Gets the underlying gobject.

const GstRingBufferSpec* Gst::RingBufferSpec::gobj | ( |  | ) | const`[inline]`

Gets the underlying gobject.

RingBufferSpec& Gst::RingBufferSpec::operator= | ( | const RingBufferSpec& | other | ) |

Assignment operator.

void Gst::RingBufferSpec::set_bigend | ( | const bool & | value | ) |

Set the endianness of the samples (in/out).

void Gst::RingBufferSpec::set_buffer_time | ( | const guint64 & | value | ) |

Set the total buffer size in microseconds (in/out).

void Gst::RingBufferSpec::set_bytes_per_sample | ( | const int & | value | ) |

Set the number of bytes of one sample (out).

This is set by the call to Gst::RingBuffer::acquire() and should probably not be set.

void Gst::RingBufferSpec::set_caps | ( | const Glib::RefPtr< Gst::Caps >& | value | ) |

Set the caps of the buffer (in).

void Gst::RingBufferSpec::set_channels | ( | const int & | value | ) |

Set the number of channels (in/out).

void Gst::RingBufferSpec::set_depth | ( | const int & | value | ) |

Set the depth of the samples (in/out).

void Gst::RingBufferSpec::set_format | ( | const Gst::BufferFormat& | value | ) |

Set the sample format (in/out).

void Gst::RingBufferSpec::set_latency_time | ( | const guint64 & | value | ) |

Set the latency in microseconds (in/out).

void Gst::RingBufferSpec::set_rate | ( | const int & | value | ) |

Set the samplerate (in/out).

void Gst::RingBufferSpec::set_seglatency | ( | const int & | value | ) |

Set the number of segments queued in the lower level device, defaults to segtotal (in/out).

void Gst::RingBufferSpec::set_segsize | ( | const int & | value | ) |

Set the size of one segment in bytes (in/out).

void Gst::RingBufferSpec::set_segtotal | ( | const int & | value | ) |

Set the total number of segments (in/out).

void Gst::RingBufferSpec::set_sign | ( | const bool & | value | ) |

Set the sample sign (in/out).

void Gst::RingBufferSpec::set_silence_sample | ( | const Glib::ArrayHandle< guint8 > & | silence_sample | ) |

Sets the bytes representing one sample of silence (out).

This is set by the call to Gst::RingBuffer::acquire() and probably should not be set.

void Gst::RingBufferSpec::set_type | ( | const Gst::BufferFormatType& | value | ) |

Set the sample type (in/out).

void Gst::RingBufferSpec::set_width | ( | const int & | value | ) |

Set the width of the samples (in/out).

void Gst::RingBufferSpec::swap | ( | RingBufferSpec& | other | ) |

The documentation for this class was generated from the following file:

- gstreamermm/ringbuffer.h